#include <iostream>

using namespace std;

int main()
{
    int n;
    cin >> n;

    int a[n];

    for(int i = 0; i < n; i++) cin >> a[i];

    int q;
    cin >> q;

    int l[q], r[q];

    for(int i = 0; i < q; i++){

        cin >> l[i] >> r[i];

        l[i]--;
        r[i]--;
    }

    bool res[q];

    for(int u = 0; u < q; u++){

        bool ind = true;

        int i = l[u];

        while(i < r[u] && ind){

            if(a[i] > a[i+1]){

                if((a[i+1] >= a[i-1] || i == l[u]) || (a[i+2] >= a[i] || i+1 == r[u])){

                    i++;

                    if(a[i+2] >= a[i]) i++;

                    while(i < r[u] && ind){

                        if(a[i] > a[i+1]) ind = false;

                        i++;
                    }

                }

                else ind = false;

            }

            i++;

        }

        res[u] = ind;

    }

    for(int i = 0; i < q; i++){

        if(res[i]) cout << "DA" << endl;

        else cout << "NE" << endl;

    }

    return 0;
}